/*
 * TestDAOBean.java
 *
 * Created on 12. unor 2007, 18:51
 *
 */

package dao;

import dto.EmployeeDTO;
import entity.Country;
import entity.Employee;
import entity.JobPosition;
import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

/**
 *
 * @author Ing. Ondrej Fafejta (fafejta.ondrej@gmail.com)
 */
@Stateless()
public class TestDAOBean implements TestDAO{
    @PersistenceContext()
    private EntityManager em;
    
    /** Creates a new instance of TestDAOBean */
    public TestDAOBean() {
    }

    public void createCountry(Country country) {
        em.persist(country);
    }
    
    public Country findCountryById(int id){
        return em.find(Country.class,id);
    }

    public void createJobPosition(JobPosition jobPosition) {
        em.persist(jobPosition);
    }
    
    public JobPosition findJobPositionById(int id){
        return em.find(JobPosition.class,id);
    }

    public void createEmployee(Employee employee) {
        em.persist(employee);
    }
    
    public Employee findEmployeeById(int id){
        return em.find(Employee.class,id);
    }
    
    @SuppressWarnings(value="unchecked")
    public List<EmployeeDTO> findAllEmployees(){
        Query query=em.createQuery("SELECT new dto.EmployeeDTO(res.id,res.country,res.note) FROM Employee res ORDER BY res.id");
        return query.getResultList();
    }
    
    @SuppressWarnings(value="unchecked")
    public List<EmployeeDTO> findAllEmployeesDoesNotWord(){
        Query query=em.createQuery("SELECT new dto.EmployeeDTO(res.id,res.country,res.note,res.position) FROM Employee res ORDER BY res.id");
        return query.getResultList();
    }
}